#include <pic/pic14regs.h>
#include <stdint.h>
#include <math.h>

uint16_t at 0x2007 __CONFIG = _BODEN_ON & _CP_OFF & _DATA_CP_OFF & _PWRTE_OFF & _WDT_OFF & _LVP_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT;

static void
display(uint8_t x)
{
	PORTA = (x & 0x0f) << 1;
	PORTB = (x & 0xf0) >> 4;
}

#define delay() _asm nop; nop; nop; nop;nop; nop; nop; nop;nop; nop; nop; nop; _endasm

void
main()
{
	uint8_t disp;
	uint8_t d;

	VREN = 1;
	VR3 = 1;
	CMCON = 0x02;	// all analog inputs, plus vref
	TRISB = 0;
	TRISA = 1;
	FSR = VRCON_ADDR;	// stupid sdcc bug

	while (1) {
		INDF = 0x88; delay();	/* VREN, VR=1000 */
		disp = 0xFF;
		if (C1OUT) {
			disp &= ~0x10;
#if 1
			INDF -= 2; delay();
			if (C1OUT) {
				disp &= ~0x20;
				INDF -= 2; delay();
				if (C1OUT) {
					disp &= ~0x40;
					INDF -= 2; delay();
					if (C1OUT) {
						disp &= ~0x80;
					}
				}
			}
#endif
		} else {
			disp &= ~0x08;
#if 1
			INDF += 2; delay();
			if (!C1OUT) {
				disp &= ~0x04;
				INDF += 2; delay();
				if (!C1OUT) {
					disp &= ~0x02;
					INDF += 2; delay();
					if (!C1OUT) {
						disp &= ~0x01;
					}
				}
			}
#endif
		}
		display(disp);
	}
}
